%********************************************
%	ed.m
%********************************************
%	Run file for optimize.dll mex file
%********************************************
	global	ngen
	global xx;
	global PrintTrace;
	global TBCs_min
	global HR_of_TBCs_min
   xx = 0;
%********************************************
! move optimize_1.log optimize_1prev.log
diary optimize_1.log

disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
disp ('  Starting ed.m Matlab procedure for the optimization with Struggle  ');
disp ('          Test edition Kb14 and then !  ');
disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
help red
disp ( ['          ',datestr(now)] );
disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
disp ('');

PrintTrace = 0;	% Intermediate printing in Matlab
PTrace = 0;			% Intermediate printing in Optimize
PnPlot = 20;		% Plot frequency (plots every so and so)
BCOname = 'Real';	% 'Int' 'Real' 'Bin'	% GAXXXBlendCrossover kind for the integer part of Mixedgenome
BCOBmut = 0.05;	% BinBlendCrossover	% When mom & dad get same gene, some probability to get the other binary value
BCORdep = 0.5;		% RealBlendCrossover	% The possible gene value interval is deployed both sides

nvar = 20				% nvar = IV_SX;
xopt = 0.9 * ones(1,nvar);
xopt(11:15) = 1;			% P integer variables	
xwei = ones(1,nvar);
xmin =  0.01 * ones(1,nvar);
xmin(11:15) = 0;	% -10;	% 0;	% P integer variables	
xmax =  0.99 * ones(1,nvar);
xmax(11:15) = 1;	% 10;	% 1;	% P integer variables	

xval =  0.5 * ones(1,nvar);
xval(11:15) = 1;	%	P integer variables	

npop = 33;	% 22;	% 66;	% 4;	% 5;
ngen = 333;	% 33;	% 533;	% 5;	% 6;
pmut = 0.0;
pcro = 1.0;
nwei = 20;		% length(X) = max(size(X));		% new K523
Dwei = ones(1,nwei);


% structure that defines general user data
UserData.inXsize = nvar;
UserData.inXopt = xopt;
UserData.inXwei = xwei;
UserData.inXmin = xmin;
UserData.inXmax = xmax;
UserData.inXval = xval;
UserData.inDsize = nwei;
UserData.inDwei = Dwei

% structure that defines the parameters
Parameters.inN_POP = npop;
Parameters.inN_GEN = ngen;
Parameters.inP_MUT = pmut;
Parameters.inP_CRO = pcro;
Parameters.BCOname = BCOname;		% inS_CRO	'Bin'
Parameters.BCOBmut = BCOBmut;		% inP_CROB	0.01
Parameters.BCORdep = BCORdep		% inF_Blend	0.5

% structure that defines the control data
Control.PnPlot = PnPlot;
Control.PTrace = PTrace

%===========================================================
figure(1)
%	defining the subplots
%	1)the improvements stages
subplot(3,1,1); axis([ 8 14   0 5000]); grid on; xlabel('Heat Recovery [kWh/batch]'); ylabel('TBCs [CHF/batch]');
%	2)the evolution of the best individual and the average "individual" as a function of the number of generations
subplot(3,1,2); axis([ 0 ngen 0 3000]); grid on; xlabel('Generation [-]'); ylabel('TBCs [CHF/batch]');
%	2)the behaviour of the OF between 0 et 1
subplot(3,1,3); axis([ 0 1 0 10]); grid on; xlabel('XX'); ylabel('Calculated OF');
pause (0.01);
%===========================================================

% initialisation of output variables
N_OF_side = 6;
OF_side   = zeros(1,N_OF_side);
disp(' ======================================================================== ');
BestGenome.inXsize = nvar;
BestGenome.inXval  = 1000000*ones(nvar,1);
brof
subplot(3,1,3); axis([ 0 1 0 600]); grid on; xlabel('XX'); ylabel('Calculated OF');
disp(' ======================================================================== ');

tic;
% BestGenome : same structure as UserData
[BestGenome, OF_side, N_OF_side] = optimize ( UserData,Parameters,Control );	% call DLL % new K927
% ========================================================================

disp(' Back after call to optimize.dll. Return to Red.m !!!!! ');
disp(' ');
brof
disp(' ');
dispnum ( N_OF_side,  'Number of side functions', '  N_OF_side' );
dispnum ( OF_side(1), 'cost function   number 1', '  OF_side(1) = Cost 1' );
dispnum ( OF_side(2), 'cost function   number 2', '  OF_side(2) = Cost 2' );
dispnum ( OF_side(3), 'cost function   number 3', '  OF_side(3) = Cost 3' );
dispnum ( OF_side(4), 'best objective function ', '  OF_side(4) = TBCs_min' );
dispnum ( OF_side(5), 'aver objective function ', '  OF_side(5) = TBCs_ave' );
dispnum ( OF_side(6), 'heat recovery at this OF', '  OF_side(6) = HR_of_TBCs_min' );
disp(' ');
disparray ( BestGenome.inXval, BestGenome.inXsize, 5, 'BestGenome' );
disp(' ');

telapsed=toc;
dispnum ( telapsed, 'time elapsed in Red.m', 'sec' );
disp(' ********************************************************************************************** ');
diary off					%	pour fermer le fichier log
clear optimize					%	pour librer le handle du fichier optimize.dll
save optimize

disp (' Press any key to see more details in 3rd graph');
pause;
subplot(3,1,3); axis([ 0.7 1.0 0.0 2*OF_side(4)]);

%********************************************
%	end of ed.m
%********************************************

